/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { IAnnotationLayerProxy_$type } from "./IAnnotationLayerProxy";
import { CrosshairLayer } from "./CrosshairLayer";
import { ValueLayer } from "./ValueLayer";
import { CalloutLayer } from "./CalloutLayer";
import { FinalValueLayer } from "./FinalValueLayer";
import { DataToolTipLayer } from "./DataToolTipLayer";
import { DoubleCollection } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnnotationLayerProxy = /*@__PURE__*/ (() => {
    class AnnotationLayerProxy extends Base {
        constructor() {
            super(...arguments);
            this._container = null;
        }
        get container() {
            return this._container;
        }
        set container(a) {
            this._container = a;
        }
        matchesType(a) {
            if (!a.eq) {
                return false;
            }
            return true;
        }
        createCrosshairLayer() {
            let a = new CrosshairLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createValueLayer() {
            let a = new ValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createCalloutLayer() {
            let a = new CalloutLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createFinalValueLayer() {
            let a = new FinalValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        setCrosshairHorizontalLineVisibility(a, b) {
            a.acf = b;
        }
        setCrosshairVerticalLineVisibility(a, b) {
            a.acg = b;
        }
        setCrosshairHorizontalLineStroke(a, b) {
            a.ab3 = b;
        }
        setCrosshairVerticalLineStroke(a, b) {
            a.ab4 = b;
        }
        setCrosshairXAxisForeground(a, b) {
            a.ab7 = b;
        }
        setCrosshairYAxisForeground(a, b) {
            a.aca = b;
        }
        setCrosshairXAxisBackground(a, b) {
            a.ab5 = b;
        }
        setCrosshairYAxisBackground(a, b) {
            a.ab8 = b;
        }
        setCrosshairYAxisPrecision(a, b) {
            a.aac = b;
        }
        setCrosshairXAxisPrecision(a, b) {
            a.aab = b;
        }
        setCrosshairOnAxesEnabled(a, b) {
            a.zu = b;
        }
        setCrosshairUseInterpolation(a, b) {
            a.zw = b;
        }
        setCrosshairThickness(a, b) {
            a.jn = b;
        }
        isCrosshairLayer(a) {
            return typeCast(CrosshairLayer.$, a) !== null;
        }
        setFinalValuePrecision(a, b) {
            a.z1 = b;
        }
        setFinalValueBackground(a, b) {
            a.aav = b;
        }
        setFinalValueForeground(a, b) {
            a.aax = b;
        }
        setContentMemberPath(a, b) {
            a.acc = b;
        }
        setCalloutsAllowedPositions(a, b) {
            a.z1 = b;
        }
        setLabelMemberPath(a, b) {
            a.acq = b;
        }
        setXMemberPath(a, b) {
            a.ac4 = b;
        }
        setYMemberPath(a, b) {
            a.ac7 = b;
        }
        setTargetSeries(a, b) {
            a.z6 = b;
        }
        setCollisionChannel(a, b) {
            a.ab9 = b;
        }
        setIsAutoCalloutBehaviorEnabled(a, b) {
            a.aau = b;
        }
        setGreedyCollisionMode(a, b) {
            a.zw = b ? 2 : 0;
        }
        setCollisionMode(a, b) {
            a.zw = b;
        }
        setUseItemColorForFill(a, b) {
            a.aa0 = b;
        }
        setUseItemColorForOutline(a, b) {
            a.aa1 = b;
        }
        setCalloutStrokeThickness(a, b) {
            a.abj = b;
        }
        setUseAutoContrastingLabelColors(a, b) {
            a.aay = b;
        }
        setCalloutBackground(a, b) {
            a.aes = b;
        }
        setAutoCalloutLabelPrecision(a, b) {
            a.abm = b;
        }
        setCalloutLightColor(a, b) {
            a.aev = b;
        }
        setCalloutDarkColor(a, b) {
            a.aet = b;
        }
        setUseDedicatedLanes(a, b) {
            a.zu = b ? 2 : 0;
        }
        isCalloutLayer(a) {
            if (typeCast(CalloutLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isDataToolTipLayer(a) {
            if (typeCast(DataToolTipLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isFinalValueLayer(a) {
            if (typeCast(FinalValueLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        addCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
        }
        removeCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
        }
        addCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateCombine(c.calloutRenderStyleUpdating, b);
        }
        removeCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateRemove(c.calloutRenderStyleUpdating, b);
        }
        setCalloutStyleUpdatingEventEnabled(a, b) {
            a.aax = b;
        }
        setUseValueForAutoCalloutLabels(a, b) {
            a.aa3 = b;
        }
        setCalloutRenderStyleUpdatingEventEnabled(a, b) {
            a.aaw = b;
        }
        updateDataToolTipPropertyByName(a, b, c) {
            a.afb(b, c);
        }
        getIsAutoCalloutBehaviorEnabled(a) {
            return a.aau;
        }
        setValueMode(a, b) {
            a.zt = b;
        }
        setValueAxisAnnotationEnabled(a, b) {
            a.zv = b;
        }
        getValueMode(a) {
            return a.zt;
        }
        isValueLayer(a) {
            return typeCast(ValueLayer.$, a) !== null;
        }
        setBrush(a, b) {
            a.u8 = b;
        }
        setDashArray(a, b) {
            let c = new DoubleCollection();
            for (let d = 0; d < b.length; d++) {
                c.add(b[d]);
            }
            a.vv = c;
        }
    }
    AnnotationLayerProxy.$t = /*@__PURE__*/ markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);
    return AnnotationLayerProxy;
})();
